import type { Hash } from "@siteimprove/alfa-hash";
import { type Parser as CSSParser } from "../../syntax/index.js";
import { Unit } from "../../unit/index.js";
import { Dimension } from "./dimension.js";
/**
 * {@link https://drafts.csswg.org/css-values/#lengths}
 *
 * @public
 */
export declare class Length<U extends Unit.Length = Unit.Length> extends Dimension<"length", U> {
    static of<U extends Unit.Length>(value: number, unit: U): Length<U>;
    private constructor();
    hasUnit<U extends Unit.Length>(unit: U): this is Length<U>;
    withUnit<U extends Unit.Length>(unit: U): Length<U>;
    isRelative(): this is Length<Unit.Length.Relative>;
    scale(factor: number): Length<U>;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): Length.JSON<U>;
    toString(): string;
}
/**
 * @public
 */
export declare namespace Length {
    interface JSON<U extends Unit.Length = Unit.Length> extends Dimension.JSON<"length", U> {
    }
    function isLength(value: unknown): value is Length;
    /**
     * {@link https://drafts.csswg.org/css-values/#lengths}
     */
    const parse: CSSParser<Length>;
}
//# sourceMappingURL=length.d.ts.map