import { type Parser as CSSParser } from "../../syntax/index.js";
import { Numeric } from "./numeric.js";
/**
 * {@link https://drafts.csswg.org/css-values/#numbers}
 *
 * @public
 */
export declare class Number extends Numeric<"number"> {
    static of(value: number): Number;
    private constructor();
    scale(factor: number): Number;
    equals(value: unknown): value is this;
    toJSON(): Number.JSON;
}
/**
 * @public
 */
export declare namespace Number {
    interface JSON extends Numeric.JSON<"number"> {
    }
    function isNumber(value: unknown): value is Number;
    /**
     * {@link https://drafts.csswg.org/css-values/#zero-value}
     */
    const parseZero: CSSParser<Number>;
    /**
     * {@link https://drafts.csswg.org/css-values/#number-value}
     */
    const parse: CSSParser<Number>;
}
//# sourceMappingURL=number.d.ts.map