import { type Parser as CSSParser } from "../syntax/index.js";
import { Keyword } from "./keyword.js";
/**
 * {@link https://drafts.csswg.org/css-backgrounds/#typedef-box}
 *
 * @public
 */
export type Box = Keyword<"border-box"> | Keyword<"padding-box"> | Keyword<"content-box">;
/**
 * @public
 */
export declare namespace Box {
    type JSON = Keyword.JSON<"border-box"> | Keyword.JSON<"padding-box"> | Keyword.JSON<"content-box">;
    const parse: CSSParser<Box>;
    /**
     * {@link https://drafts.csswg.org/css-shapes/#typedef-shape-box}
     */
    type Shape = Box | Keyword<"margin-box">;
    namespace Shape {
        type JSON = Box.JSON | Keyword.JSON<"margin-box">;
    }
    const parseShape: CSSParser<Shape>;
    /**
     * {@link https://drafts.fxtf.org/css-masking/#typedef-geometry-box}
     */
    type Geometry = Shape | Keyword<"fill-box"> | Keyword<"stroke-box"> | Keyword<"view-box">;
    namespace Geometry {
        type JSON = Shape.JSON | Keyword.JSON<"fill-box"> | Keyword.JSON<"stroke-box"> | Keyword.JSON<"view-box">;
    }
    const parseGeometry: CSSParser<Geometry>;
}
//# sourceMappingURL=box.d.ts.map