import { Parser } from "@siteimprove/alfa-parser";
import type { Parser as CSSParser } from "../../syntax/index.js";
import { Keyword } from "../keyword.js";
import { LengthPercentage } from "../numeric/index.js";
import type { Keywords } from "./keywords.js";
import { Side } from "./side.js";
/**
 * @public
 */
export type Component<S extends Keywords.Horizontal | Keywords.Vertical = Keywords.Horizontal | Keywords.Vertical, O extends LengthPercentage = LengthPercentage> = Keywords.Center | Side<S, O>;
/**
 * @public
 */
export declare namespace Component {
    type Canonical<S extends Keywords.Horizontal | Keywords.Vertical> = Keywords.Center | Side.Canonical<S>;
    type PartiallyResolved<S extends Keywords.Horizontal | Keywords.Vertical> = Keywords.Center | Side.PartiallyResolved<S>;
    type JSON = Keyword.JSON | Side.JSON;
    type Resolver = Side.Resolver;
    function resolve<S extends Keywords.Horizontal | Keywords.Vertical>(resolver: Resolver): (value: Component<S>) => Canonical<S>;
    type PartialResolver = Side.PartialResolver;
    function partiallyResolve<S extends Keywords.Horizontal | Keywords.Vertical>(resolver: PartialResolver): (value: Component<S>) => PartiallyResolved<S>;
    /**
     * Parses an isolated offset (length-percentage), and adds the provided default
     * side to make a Side.
     *
     * @internal
     */
    function parseOffset<T extends Keywords.Horizontal | Keywords.Vertical>(side: T): CSSParser<Component<T>>;
    /**
     * @internal
     */
    const parseHorizontal: Parser<import("@siteimprove/alfa-slice").Slice<import("../../syntax/token.js").Token>, Keyword<"center"> | Side<Keyword.ToKeywords<"right" | "left">, LengthPercentage> | Side<Keyword.ToKeywords<"right" | "left">, never> | Component<Keyword<"left">, LengthPercentage>, string, []>;
    /**
     * @internal
     */
    const parseVertical: Parser<import("@siteimprove/alfa-slice").Slice<import("../../syntax/token.js").Token>, Keyword<"center"> | Side<Keyword.ToKeywords<"top" | "bottom">, LengthPercentage> | Side<Keyword.ToKeywords<"top" | "bottom">, never> | Component<Keyword<"top">, LengthPercentage>, string, []>;
}
//# sourceMappingURL=component.d.ts.map